Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3610)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3611)
@@ -1349,39 +1247,40 @@
                    ENDDO
                 
-             !> General case (other species)
+                !
+                !-- any other species
                 ELSE
 
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*con_factor*hour_per_day
- 
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr) 
-
-                ENDIF  ! IF (spc_names==)
-
-                !> for every species and category set emis to 0 so to avoid overwriting. TBD: discuss whether necessary
-
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &
+                                                  con_factor * hour_per_day
+ 
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                 delta_emis(nys:nyn,nxl:nxr) 
+
+                ENDIF
+                
                 emis(:,:)= 0 
-
+                
              ENDDO
-
-          !> for every category set delta_emis to 0 so to avoid overwriting. TBD: discuss whether necessary
-
-          delta_emis(:,:)=0 
- 
+             
+             delta_emis(:,:)=0 
+          
           ENDDO
 
-       ENDIF  !> mode_emis
-
-!-------------------------------------------------------------------------------------------------------
-!--- Cycle to transform x,y coordinates to the one of surface_mod and to assign emission values to cssws
-!-------------------------------------------------------------------------------------------------------
-
+       ENDIF
+
+       
+!
+!-- Cycle to transform x,y coordinates to the one of surface_mod and to assign emission values to cssws
+!
 !-- PARAMETERIZED mode
-       !> For the PARAMETERIZED mode units of inputs are always micromoles/(m**2*s). In this case we do not need the molar mass for conversion into ppms
-       IF (TRIM(mode_emis)=="PARAMETERIZED") THEN
+       !
+       !-- Units of inputs are micromoles/(m**2*s)
+       IF ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
 
           IF ( street_type_f%from_file )  THEN
 
-       !> Streets are lsm surfaces, hence, no usm surface treatment required
-             IF (surf_lsm_h%ns .GT. 0 ) THEN
+             !
+             !-- Streets are lsm surfaces, hence, no usm surface treatment required
+             IF ( surf_lsm_h%ns > 0 )  THEN
                 DO  m = 1, surf_lsm_h%ns
                    i = surf_lsm_h%i(m)
@@ -1389,34 +1288,33 @@
                    k = surf_lsm_h%k(m)
 
-
                    IF ( street_type_f%var(j,i) >= main_street_id  .AND. street_type_f%var(j,i) < max_street_id )  THEN
 
-                   !> Cycle over already matched species
-                      DO  ispec=1,nspec_out
-
-                         !> PMs are already in mass units: kilograms 
-                         IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
-
-                            !              kg/(m^2*s) *kg/m^3
+                      !
+                      !-- Cycle over matched species
+                      DO  ispec = 1, nspec_out
+
+                         !
+                         !-- PMs are already in kilograms 
+                         IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1 "  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) )=="PM10")  THEN
+
+                            !
+                            !--           kg/(m^2*s) * kg/m^3
                             surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec)) * &
-                            !                                                       kg/(m^2*s)
-                                                                                emis_distribution(1,j,i,ispec)*        &
-                            !                                                    kg/m^3
-                                                                                rho_air(k)   
-
+                                                                           emis_distribution(1,j,i,ispec) *            &  !< in kg/(m^2*s)
+                                                                            rho_air(k)                                    !< in kg/m^3
+                            
+                         !
+                         !-- Other Species
+                         !-- Inputs are micromoles
                          ELSE
 
-                         !> Other Species: inputs are micromoles: they have to be converted in moles
-                         !                 ppm/s *m *kg/m^3                
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec))*   &
-                         !                                                    micromoles/(m^2*s)
-                                                                          emis_distribution(1,j,i,ispec) *              &
-                         !                                                    m^3/Nmole
-                                                                          conv_to_ratio(k,j,i)*                         &       
-                         !                                                    kg/m^3
-                                                                          rho_air(k)   
- 
+                            !   
+                            !--             ppm/s *m *kg/m^3                
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec)) * &
+                                                                           emis_distribution(1,j,i,ispec) *            &  !< in micromoles/(m^2*s)
+                                                                            conv_to_ratio(k,j,i) *                     &  !< in m^3/Nmole     
+                                                                             rho_air(k)                                   !< in kg/m^3
 
                          ENDIF
@@ -1427,30 +1325,30 @@
                    ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND. street_type_f%var(j,i) < main_street_id )  THEN
 
-                   !> Cycle over already matched species
-                      DO  ispec=1,nspec_out
-
-                         !> PMs are already in mass units: micrograms
-                         IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
-
-                            !              kg/(m^2*s) *kg/m^3                               
-                            surf_lsm_h%cssws(match_spec_model(ispec),m)= emiss_factor_side(match_spec_input(ispec)) *   &
-                            !                                                       kg/(m^2*s)
-                                                                                emis_distribution(1,j,i,ispec)*        &
-                            !                                                    kg/m^3
-                                                                                rho_air(k)   
+                      !
+                      !-- Cycle over matched species
+                      DO  ispec = 1, nspec_out
+
+                         !
+                         !-- PMs are already in kilograms
+                         IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1"  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
+
+                            !
+                            !--           kg/(m^2*s) * kg/m^3
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) * &
+                                                                           emis_distribution(1,j,i,ispec) *            &  !< in kg/(m^2*s)
+                                                                            rho_air(k)                                    !< in kg/m^3   
+                         !
+                         !-- Other species
+                         !-- Inputs are micromoles
                          ELSE
                        
-
-                         !>Other Species: inputs are micromoles
-                         !                 ppm/s *m *kg/m^3                
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) *   &
-                         !                                                    micromoles/(m^2*s)
-                                                                          emis_distribution(1,j,i,ispec) *              &
-                         !                                                    m^3/Nmole
-                                                                          conv_to_ratio(k,j,i)*                         &       
-                         !                                                    kg/m^3
-                                                                          rho_air(k)   
+                            !   
+                            !--             ppm/s *m *kg/m^3      
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) * &
+                                                                           emis_distribution(1,j,i,ispec) *            &  !< in micromoles/(m^2*s)
+                                                                            conv_to_ratio(k,j,i) *                     &  !< in m^3/Nmole       
+                                                                             rho_air(k)                                   !< in kg/m^3   
                          ENDIF
 
@@ -1459,5 +1357,6 @@
                    ELSE
 
-                   !> If no street type is defined, then assign null emissions to all the species
+                      !
+                      !-- If no street type is defined, then assign zero emission to all the species
                       surf_lsm_h%cssws(:,m) = 0.0_wp
 
@@ -1465,16 +1364,19 @@
 
                 ENDDO
+
              ENDIF
 
           ENDIF
 
-       !> For both DEFAULT and PRE-PROCESSED
+       !
+       !-- For both DEFAULT and PRE-PROCESSED mode
        ELSE    
        
 
-          DO ispec=1,nspec_out 
-                                !TBD: for the PRE-PROCESSED mode in the future, values at different heights should be included!            
-             !> Default surface type
-             IF (surf_def_h(0)%ns .GT. 0) THEN
+          DO ispec = 1, nspec_out 
+                   
+             !
+             !-- Default surfaces
+             IF ( surf_def_h(0)%ns > 0 )  THEN
 
                 DO  m = 1, surf_def_h(0)%ns
@@ -1485,42 +1387,40 @@
                    IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
 
-
-                      !> Distinguish between PMs (no needing conversion in ppms), 
-                      !  VOC (already converted to moles/(m**2*s) using conv_factors: they do not need molar masses for their conversion to PPMs ) and
-                      ! other Species (still expressed in Kg/(m**2*s) at this point)
-
-                      !> PMs
-                      IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                      !
+                      !-- PMs
+                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1"  &
+                           .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
                    
-                         !            kg/(m^2*s) *kg/m^3                         kg/(m^2*s)                 
-                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*   &
-                         !                                                  kg/m^3
-                                                                          rho_air(nzb)   
+                         !
+                         !--            kg/(m^2*s) *kg/m^3                         kg/(m^2*s)                 
+                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*  &
+                                                                           rho_air(nzb)                           !< in kg/m^3  
  
  
                       ELSE
 
-                         !> VOCs
-                         IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
-                            !          ( ppm/s) * m * kg/m^3                         mole/(m^2/s)   
-                            surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                            !    m^3/mole          ppm
-                                                                             conv_to_ratio(nzb,j,i)*ratio2ppm *      &
-                         !                                                    kg/m^3
-                                                                             rho_air(nzb)   
-
-
-                         !> OTHER SPECIES
+                         !
+                         !-- VOCs
+                         IF ( len_index_voc > 0 .AND. emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
+                            !
+                            !--           (ppm/s) * m * kg/m^3                        mole/(m^2/s)   
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &
+                                                                              conv_to_ratio(nzb,j,i) *         &  !< in m^3/mole
+                                                                               ratio2ppm *                     &  !< in ppm
+                                                                                rho_air(nzb)                      !< in kg/m^3  
+
+
+                         !
+                         !-- Other species
                          ELSE
 
-                            !               ( ppm/s )*m  * kg/m^3                      kg/(m^2/s)                      
-                            surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                               !  mole/Kg        
-                                                                             (1/emt_att%xm(ispec))*                &
-                            !                                                    m^3/mole          ppm
-                                                                             conv_to_ratio(nzb,j,i)*ratio2ppm*       &
-                            !                                                  kg/m^3
-                                                                             rho_air(nzb)   
+                            !
+                            !--           (ppm/s) * m  * kg/m^3                    kg/(m^2/s)
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &       
+                                                                              ( 1.0_wp / emt_att%xm(ispec) ) * &  !< in mole/kg 
+                                                                                conv_to_ratio(nzb,j,i) *       &  !< in m^3/mole  
+                                                                                 ratio2ppm *                   &  !< in ppm 
+                                                                                  rho_air(nzb)                    !< in  kg/m^3  
   
 
@@ -1533,8 +1433,9 @@
                 ENDDO
 
-             END IF
+             ENDIF
          
-             !-- Land Surface Mode surface type
-             IF (surf_lsm_h%ns .GT. 0) THEN
+             !
+             !-- LSM surfaces
+             IF ( surf_lsm_h%ns > 0 )  THEN
 
                 DO m = 1, surf_lsm_h%ns
@@ -1546,39 +1447,37 @@
                    IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
 
-                      !> Distinguish between PMs (no needing conversion in ppms), 
-                      !  VOC (already converted to moles/(m**2*s) using conv_factors: they do not need molar masses for their conversion to PPMs ) and
-                      ! other Species (still expressed in Kg/(m**2*s) at this point)
-
-                      !> PMs
-                      IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                      !
+                      !-- PMs
+                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1"  &
+                           .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
    
-                         !         kg/(m^2*s) * kg/m^3                           kg/(m^2*s)            
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *              &
-                         !                                                  kg/m^3
-                                                                          rho_air(k)   
+                         !
+                         !--         kg/(m^2*s) * kg/m^3                           kg/(m^2*s)            
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &
+                                                                        rho_air(k)                                !< in kg/m^3
  
                       ELSE
 
-                         !> VOCs
-                         IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
-                            !          ( ppm/s) * m * kg/m^3                        mole/(m^2/s)   
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                          !    m^3/mole          ppm
-                                                                          conv_to_ratio(k,j,i)*ratio2ppm*    &
-                         !                                                 kg/m^3
-                                                                          rho_air(k)   
-
-                         !> OTHER SPECIES
+                         !
+                         !-- VOCs
+                         IF ( len_index_voc > 0 .AND. emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
+                            !
+                            !--          (ppm/s) * m * kg/m^3                        mole/(m^2/s)   
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &     
+                                                                           conv_to_ratio(k,j,i) *           &     !< in m^3/mole
+                                                                            ratio2ppm *                     &     !< in ppm
+                                                                             rho_air(k)                           !< in kg/m^3  
+
+                         !
+                         !-- Other species
                          ELSE
-   
-                            !         ( ppm/s) * m * kg/m^3                        kg/(m^2/s)                      
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *               &
-                                                                               !  mole/Kg    
-                                                                         (1/emt_att%xm(ispec))*                          &
-                            !                                                m^3/mole           ppm
-                                                                         conv_to_ratio(k,j,i)*ratio2ppm*                 &
-                            !                                            kg/m^3
-                                                                         rho_air(k)   
+                            !
+                            !--           (ppm/s) * m  * kg/m^3                    kg/(m^2/s)
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  & 
+                                                                           ( 1.0_wp / emt_att%xm(ispec) ) * &     !< in mole/kg
+                                                                            conv_to_ratio(k,j,i) *          &     !< in m^3/mole
+                                                                             ratio2ppm *                    &     !< in ppm
+                                                                              rho_air(k)                          !< in kg/m^3     
                                                       
                          ENDIF
@@ -1590,8 +1489,9 @@
                 ENDDO
 
-             END IF
-
-             !-- Urban Surface Mode surface type
-             IF (surf_usm_h%ns .GT. 0) THEN
+             ENDIF
+
+             !
+             !-- USM surfaces
+             IF ( surf_usm_h%ns > 0 )  THEN
 
 
@@ -1604,37 +1504,39 @@
                    IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
 
-                      !> PMs
-                      IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                      !
+                      !-- PMs
+                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1" &
+                           .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
+                             .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
                       
-                         !          kg/(m^2*s) *kg/m^3                             kg/(m^2*s)                     
-                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*        & 
-                         !                                              kg/m^3
-                                                                       rho_air(k)   
+                         !
+                         !--          kg/(m^2*s) *kg/m^3                             kg/(m^2*s)                     
+                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*  & 
+                                                                        rho_air(k)                                !< in kg/m^3
 
  
                       ELSE
-
-                         !> VOCs
-                         IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
-                            !          ( ppm/s) * m * kg/m^3                        mole/(m^2/s)   
-                            surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *   &
-                                                                          !    m^3/mole          ppm
-                                                                          conv_to_ratio(k,j,i)*ratio2ppm*    &
-                         !                                                kg/m^3
-                                                                          rho_air(k)   
-
-                         !> OTHER SPECIES
+                         
+                         !
+                         !-- VOCs
+                         IF ( len_index_voc > 0 .AND. emt_att%species_name(match_spec_input(ispec)) == "VOC" ) THEN
+                            !
+                            !--          (ppm/s) * m * kg/m^3                        mole/(m^2/s)   
+                            surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &
+                                                                           conv_to_ratio(k,j,i) *           &     !< in m^3/mole
+                                                                            ratio2ppm *                     &     !< in ppm
+                                                                             rho_air(k)                           !< in kg/m^3   
+
+                         !
+                         !-- Other species
                          ELSE
 
-
-                         !            ( ppm/s) * m * kg/m^3                        kg/(m^2/s)                      
-                            surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                             !  mole/Kg    
-                                                                         (1/emt_att%xm(ispec))*                 &
-                            !                                                m^3/mole           ppm
-                                                                         conv_to_ratio(k,j,i)*ratio2ppm*        &
-                            !                                            kg/m^3
-                                                                         rho_air(k)   
+                            !
+                            !--          (ppm/s) * m * kg/m^3                        kg/(m^2/s)                      
+                            surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *  &   
+                                                                           ( 1.0_wp / emt_att%xm(ispec) ) * &     !< in mole/kg
+                                                                            conv_to_ratio(k,j,i) *          &     !< in m^3/mole
+                                                                             ratio2ppm*                     &     !< in ppm
+                                                                              rho_air(k)                          !< in kg/m^3   
 
 
@@ -1646,16 +1548,16 @@
  
                 ENDDO
-             END IF
+
+             ENDIF
+
           ENDDO
 
-       ENDIF 
-
-
-    !> At the end of each call to chem_emissions setup, the time_factor is deallocated (ALLOCATED ONLY in the DEFAULT mode) 
-
+       ENDIF
+
+       !
+       !-- Deallocate time_factor in case of DEFAULT mode) 
        IF ( ALLOCATED ( time_factor ) ) DEALLOCATE( time_factor )
 
-   ENDIF !> emis_output_required
-
+   ENDIF
 
  END SUBROUTINE chem_emissions_setup
